-- alter to phistory
--alter table pcost  add primary key ( ser );
alter table phistory add column pcost integer;
alter table phistory add foreign key
       ( pcost ) references pcost ;

-- alter to pcost

alter table pcost add column original_qty integer ;
alter table pcost add column qty_invoiced integer ;

-- alter to asset_reg

alter table asset_reg add column equipment_suspense char(6);
alter table asset_reg add foreign key ( equipment_suspense ) references nominal;

-- new table used to keep track of pcost parent rows---
create table pcostxref (
parent          integer,
child           integer
);

-- Function: asatdate(date)

-- DROP FUNCTION asatdate(date);

CREATE OR REPLACE FUNCTION asatdate(asat date)
  RETURNS sp_status AS
$BODY$
declare     unmatched_row       unmatched%rowtype;
            pcost_row           record;
            Psumunmatched      integer;
            Psumpcost           integer;
			firstline			integer;
             cur_asset_reg char(1);
            cur_pdesc   char(4);
            cur_reg char(6);
            cur_qty integer;
            cur_dat date;
            cur_qty_unmatched integer;
            cur_qty_matched integer;
            cur_qty_sold integer;
            cur_sales_period date;
            cur_nominal_period date;
            cur_unit_cost decimal(16,2);
            cur_unit_depn decimal(16,2);
            cur_supp char(6);
            cur_invoice_ref char(10);
            cur_location integer;
            cur_pcost_ser integer;
            cur_qty_invoiced integer;			
            err			sp_status;

                                
begin 

         
drop table if exists temp_unmatched;
drop table if exists temp_pcost;

create temp table temp_unmatched
  (
      ser serial not null ,
      asset_reg char(1),
      pdesc char(4),
      reg char(6),
      qty integer,
      dat date,
      cost_per_unit decimal(9,2),
      supplier char(6),
      qty_left integer,
      qty_sold integer,
      location smallint
        );

create temp table temp_pcost
     (
      ser integer,
      asset_reg char(1),
      pdesc char(4),
      reg char(6),
      unit_cost decimal(16,2),
      unit_depn decimal(16,2),
      qty integer,
      dat date,
      supplier char(6),
      invoice_ref char(10),
      source_type char(1),
      original_qty integer,
      qty_invoiced integer
       );



	cur_qty_matched :=0;
	firstline := 1;
	
	for pcost_row in  
	    select h.pcost as pcost, h.ser, h.asset_reg, h.pdesc, h.reg,
                   h.typ, h.sales_period,
                   h.dat, h.unit_cost, h.unit_depn, h.qty,
                   h.supp, h.invoice_ref, h.location, pd.typ as pdtyp
          
        from phistory h, pdesc pd
	    where h.sales_period <= asat
	    and h.pdesc = pd.cod
	    and h.pcost is not null
        order by 1,2	
	loop
	
	    if firstline = 1 then
	       cur_pcost_ser     := pcost_row.pcost;
           cur_asset_reg     := pcost_row.asset_reg;
           cur_pdesc         := pcost_row.pdesc;
           cur_reg           := pcost_row.reg;
           cur_qty           := 0;
           cur_qty_unmatched := 0;
           cur_qty_matched   := 0;
           cur_qty_sold      := 0;
           cur_unit_cost     := 0;
           cur_unit_depn     := 0;
           cur_invoice_ref   := '';
           cur_supp          := '';
           cur_location      := 1;
           cur_qty_invoiced  := 0;
           firstline         := 0;
        end if;
	
       if cur_pcost_ser <> pcost_row.pcost then

           if cur_qty_matched > 0 then
              
	           execute 'insert into temp_pcost values (' || coalesce(quote_literal(cur_pcost_ser),'NULL') || ','
                                            || coalesce(quote_literal(cur_asset_reg),'NULL') || ','
                                            || coalesce(quote_literal(cur_pdesc),'NULL')     ||','
                                            || coalesce(quote_literal(cur_reg),'NULL')        ||','
                                            || coalesce(quote_literal(cur_unit_cost),'NULL') ||','
                                            || coalesce(quote_literal(cur_unit_depn),'NULL') ||','
                                            || coalesce(quote_literal(cur_qty_matched),'NULL')       ||','
                                            || coalesce(quote_literal(cur_dat),'NULL')       ||','
                                            || coalesce(quote_literal(cur_supp),'NULL')    ||','
                                            || coalesce(quote_literal(cur_invoice_ref),'NULL') ||','
                                            || coalesce(quote_literal(''),'NULL') ||','
											|| coalesce(quote_literal(cur_qty_matched),'NULL') ||','
											|| coalesce(quote_literal(cur_qty_invoiced),'NULL') ||
                                            ');';					 
           end if;

	       cur_pcost_ser     := pcost_row.pcost;
           cur_asset_reg     := pcost_row.asset_reg;
           cur_pdesc         := pcost_row.pdesc;
           cur_reg           := pcost_row.reg;
           cur_qty           := 0;
           cur_qty_unmatched := 0;
           cur_qty_matched   := 0;
           cur_qty_sold      := 0;
           cur_unit_cost     := 0;
           cur_unit_depn     := 0;
           cur_invoice_ref   := '';
           cur_supp          := '';
           cur_location      := 1;
           cur_qty_invoiced  := 0;
           

        end if;	
	
       if pcost_row.typ = 1 then
             cur_dat           := pcost_row.dat;
             cur_invoice_ref   := pcost_row.invoice_ref;
             cur_supp          := pcost_row.supp;
             cur_location      := pcost_row.location;
             cur_unit_cost     := pcost_row.unit_cost;
             cur_unit_depn     := pcost_row.unit_depn;
             cur_qty_matched   := cur_qty_matched   + pcost_row.qty;
        end if;
		
        if pcost_row.typ = 2 then
            cur_invoice_ref   := pcost_row.invoice_ref;
            cur_supp          := pcost_row.supp;
            cur_unit_cost     := pcost_row.unit_cost;
            cur_qty_invoiced  := cur_qty_invoiced  + pcost_row.qty;
        end if;
		
        if pcost_row.typ = 3 then
            if pcost_row.pdtyp = "M" then
                cur_qty_matched   := cur_qty_matched   - pcost_row.qty;
            else
                cur_qty_matched := 0;
            end if;
        end if;
		
        if pcost_row.typ = 4 then
            cur_unit_depn     := cur_unit_depn     + pcost_row.unit_depn;
        end if;	
		
        if pcost_row.typ = 5 then
            if pcost_row.qty > 0 then
                cur_unit_cost := pcost_row.unit_cost;
            end if;
        end if;

        if pcost_row.typ = 6 then
            cur_qty           := cur_qty           - hst_qty;
        end if;
		
		
        if pcost_row.typ = 7 then
            cur_dat           := pcost_row.dat;
            cur_invoice_ref   := pcost_row.invoice_ref;
            cur_supp          := pcost_row.supp;
            cur_location      := pcost_row.location;
            cur_unit_cost     := pcost_row.unit_cost;
            cur_unit_depn     := pcost_row.unit_depn;
            cur_qty_matched   := cur_qty_matched   + pcost_row.qty;
        end if;
		
        if pcost_row.typ = 8 then
            if pcost_row.pdtyp = "M" then
                cur_qty_matched   := cur_qty_matched   - pcost_row.qty;
            else
                cur_qty_matched   = 0;
            end if;
        end if;
        
        if pcost_row.typ = 9 then
            cur_unit_depn     := cur_unit_depn     + pcost_row.unit_depn;
        end if;

	if pcost_row.typ = 10 then
            cur_qty_invoiced  := cur_qty_invoiced  - pcost_row.qty;
        end if;
   
   
      

	
	end loop;
	
	
	if cur_qty_matched <> 0 then
               execute 'insert into temp_pcost values (' || coalesce(quote_literal(cur_pcost_ser),'NULL') || ','
                                            || coalesce(quote_literal(cur_asset_reg),'NULL') || ','
                                            || coalesce(quote_literal(cur_pdesc),'NULL')     ||','
                                            || coalesce(quote_literal(cur_reg),'NULL')        ||','
                                            || coalesce(quote_literal(cur_unit_cost),'NULL') ||','
                                            || coalesce(quote_literal(cur_unit_depn),'NULL') ||','
                                            || coalesce(quote_literal(cur_qty_matched),'NULL')       ||','
                                            || coalesce(quote_literal(cur_dat),'NULL')       ||','
                                            || coalesce(quote_literal(cur_supp),'NULL')    ||','
                                            || coalesce(quote_literal(cur_invoice_ref),'NULL') ||','
                                            || coalesce(quote_literal(''),'NULL') ||','
											|| coalesce(quote_literal(cur_qty_matched),'NULL') ||','
											|| coalesce(quote_literal(cur_qty_invoiced),'NULL') ||
                                            ');';					 
    end if;

	execute 'create unique index t_ix312_1 on temp_pcost (ser)';
    execute 'create index t_multidx on temp_pcost (pdesc);';
    execute 'create index pcix2 on temp_pcost (asset_reg,pdesc,reg)';
	
	
	
	
    
    err.ret_stat := 0;
    err.ret_string := 'SUCCESS';

    return err;
      
              
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION asatdate(date) OWNER TO postgres;


-- Fix the issue where getpluprices is returning 0 for discount rate instead of null , in certain
-- cases


-- Function: getpluprices(aproducttype integer, apricelist integer, adiscstruct integer)

-- DROP FUNCTION getpluprices(aproducttype integer, apricelist integer, adiscstruct integer);

CREATE OR REPLACE FUNCTION getpluprices(aproducttype integer, apricelist integer, adiscstruct integer)
 RETURNS jp_pluprices AS
$BODY$
/*
--Kevin : 6th March 2003

This procedure returns basic product_type details, plus the Master,
Promotional and Customers prices where and if appropriate.

MASTER -->      Standard price of a product type, with Discount
                if Discount Structure specified.
PROMOTIONAL --> If the item is set on a promotional price.
                Get the Promotional Price, NO DISCOUNTs are applicable
                when dealing with Promotional prices.
CUSTOMER'S -->  If Price Specified, check for pricelist value, if none
                exists use MASTER price.
                If Discount Structure specified apply it to value.
*/

-- Internal Variables

declare pPLU                             char(7);
       pDescription                     char(90);
       pProdCode                        char(7);
       pProdDescription                 char(90);
       pCostPrice                       decimal(16,2);
       pVatCode                         integer;
       pVatRate                         decimal(4,2);
       pMasterSP                        decimal(16,4);
       pCustomerSP                      decimal(16,4);
       pPromoSP                         decimal(16,4);
       pSellPrice                       decimal(16,4);
       pDiscountRate                    decimal(4,2);
       pDiscount                        decimal(16,2);
       pDiscountable                    smallint;
       pLookForDisc                     smallint;
       pCheckPLDisc                     smallint;

       pProduct                         integer;   -- Product Nsuk
       pStockUnit                       char(10);  -- Product Stock Unit
       pRowCnt                          smallint;  -- No. of rows returned
       pPLNsuk                          integer;   -- Holds PriceList Nsuk
       pPromoNsuk                       integer;   -- Holds Promotion Nsuk
       pDSNsuk                          integer;   -- Holds DiscStruct Nsuk
       pDept                            integer;   -- Department
       pDeptGroup                       integer;   -- Department Group
       pPLparent                        integer;   -- Parent price list
       pSellPriceType                   smallint;  -- Sell Price Type
       ret_price             jp_pluprices;

begin


  pMasterSP := 0.00;
  pCustomerSP := 0.00;
  pPromoSP := 0.00;
  pSellPrice := 0.00;
  pDiscountRate := 0.00;
  pDiscount := 0.00;
  pSellPriceType := 0;
  pPromoNsuk := 0;
  pStockUnit := '';

  pLookForDisc := 1;
  pCheckPLDisc := 0;

/* Intialise the jp_pluprices type to what it will be if we have to return an error
*/

  ret_price.pt := 0;
  ret_price.plu := '';
  ret_price.plu_description := '';
  ret_price.product_code := '';
  ret_price.product_description := '';
  ret_price.cost_price := 0;
  ret_price.vat_code := 0;
  ret_price.vat_rate := 0;
  ret_price.master_price := 0;
  ret_price.promotional_price := 0;
  ret_price.customer_price := 0;
  ret_price.sell_price := 0;
  ret_price.discount_rate := 0;
  ret_price.discount_value := 0;
  ret_price.sell_pricetype := 0;
  ret_price.stock_unit := '';

-- Step One : Get product_type details

       SELECT  plu, product, descr, curr_cost_price, curr_sell_price
       INTO    pPLU, pProduct, pDescription, pCostPrice, pMasterSP
       FROM    product_type
       WHERE   nsuk = aProductType;

   get diagnostics pRowCnt = ROW_COUNT;

       if pRowCnt > 1 then
               ret_price.err_code = 1;
               ret_price.err_text = 'More than one rows returned for PLU';
               return ret_price;
       end if;

       if pRowCnt = 0 then
               ret_price.err_code = 1;
               ret_price.err_text = 'No rows returned for PLU';
               return ret_price;
       end if;

-- Step 2 : Get Vat Rate and Code.
    -- Get VatCode from Product
    -- Get VatRate from Vat

    SELECT p.vcode, v.rate, p.cod, p.description, p.stock_unit
    INTO   pVatCode, pVatRate, pProdCode, pProdDescription, pStockUnit
    FROM   product p, vat v
    WHERE  p.nsuk = pProduct
      AND  p.vcode = v.cod;

    if pStockUnit is null then
      pStockUnit := '';
    end if;


-- Step 3 : Get Dept and Dept_Group Details

   SELECT dg.dept, dg.nsuk
   INTO pDept, pDeptGroup
   FROM dept_group dg , product p
   WHERE p.nsuk = pProduct
     AND p.dept_group = dg.nsuk;


-- Step 4 : Check if pricelist is Discountable or not

   if aPriceList <> 0 then
     SELECT parent
     INTO pPLparent
     FROM pricelist
     WHERE nsuk = aPricelist;

     if pPLparent is null then
       pPLparent := 0;
     end if;

   end if;

   pDiscountable := 1;


-- Step 5 : Check see if a Promotional Price exists for this item.
    -- Get NSUK for PROMOTION price list (if it exists).

    SELECT nsuk
    INTO pPromoNsuk
    FROM pricelist
    WHERE cod = 'PROMOTION';

    -- If we Found PROMOTION pricelist

    get diagnostics pRowCnt = ROW_COUNT;
    if pRowCnt = 1 then

       -- Check for PLU on Promotion Price List

       SELECT sell_price
       INTO   pPromoSP
       FROM pricelist_det
       WHERE pricelist = pPromoNsuk
         AND product_type = aProductType;

       if not FOUND then

           SELECT sell_price
           INTO   pPromoSP
           FROM pricelist_det
           WHERE pricelist = pPromoNsuk
             AND product = pProduct;

           if not FOUND then
              pPromoSP = 0;
           else
              pLookForDisc = 0;    -- Don't Look for Discount
           end if;
       else
           pLookForDisc = 0;        -- Don't Look for Discount
       end if;

    end if;

-- Step 6 : Check see if a Customer Price exists for this item.

    -- Step 6.1 : If Customer gave a Price List, Check list for Price

    if aPriceList > 0 then

         SELECT sell_price
         INTO   pCustomerSP
         FROM pricelist_det
         WHERE pricelist = aPriceList
           AND product_type = aProductType;

         if not FOUND then

             SELECT sell_price
             INTO   pCustomerSP
             FROM pricelist_det
             WHERE pricelist = aPriceList
               AND product = pProduct;

             if not FOUND then

                 if pPLparent <> 0 then
                     SELECT sell_price
                     INTO   pCustomerSP
                     FROM pricelist_det
                     WHERE pricelist = pPLparent
                       AND product_type = aProductType;

                     if not FOUND then

                         SELECT sell_price
                         INTO   pCustomerSP
                         FROM pricelist_det
                         WHERE pricelist = pPLparent
                           AND product = pProduct;

                         if not FOUND then
                            pCustomerSP = 0;
                         else
                            pCheckPLDisc = 1;        --  Look for Discount
                         end if;
                     else
                         pCheckPLDisc = 1;        --  Look for Discount
                     end if;
                 else
                    -- there is no parent price list
                    pCustomerSP = 0;
                 end if;
             else
                 pCheckPLDisc = 1;
             end if;
         else
             pCheckPLDisc = 1;        --  Look for Discount
         end if;

         pDiscountable := null;

         if pCheckPLDisc = 1 then
            SELECT discountable
            INTO pDiscountable
            FROM pricelist
            WHERE nsuk = aPricelist;

            if pDiscountable is null then
              pDiscountable := 0;
            end if;

            if pDiscountable = 0 then
              pLookForDisc := 0;
            end if;
         end if;

    end if;

-- Step 7: Get Discount Structure Details, IF ANY

  if aDiscStruct <> 0 then

    if pLookForDisc > 0 then

       -- First Check for Discount price for DEPT and DEPT GROUP
       SELECT distinct(discount)
       INTO pDiscountRate
       FROM disc_detail
       WHERE disc_struct = aDiscStruct
         -- AND department = pDept
         AND dept_group = pDeptGroup;

      get diagnostics pRowCnt = ROW_COUNT;
      -- If No results for Dept and Dept Group
      if pRowCnt <> 1 then

          -- Then Check for Discount for just Dept

          SELECT distinct(discount)
          INTO pDiscountRate
          FROM disc_detail
          WHERE disc_struct = aDiscStruct
            AND department = pDept
            AND (dept_group is null or dept_group = -1);

          get diagnostics pRowCnt = ROW_COUNT;
          -- If No Results then Discount is Zero
          if pRowCnt <> 1 then
             pDiscountRate := null;
          end if;

      end if;

    else
       pDiscountRate := null;
    end if; -- if pDiscountable > 0

  end if; -- if aDiscStruct <> ''


-- Step 8: Work out SELL_PRICE to use.

    -- If we have a promotional Price USE THAT
    if pPromoSP > 0 then
       pSellPrice := pPromoSP;
       pSellPriceType := 1;
    else
       -- NOT promo price so see if Customer or Standard price to be used

       if pCustomerSP > 0 then

          -- if Theres a Discount, apply it
          if pDiscountRate is not null then
             pDiscount := ( pCustomerSP / 100 ) * pDiscountRate;
          else
             pDiscount := null;
          end if;

          pSellPrice := pCustomerSP;
          pSellPriceType := 2;
       else

          -- if Theres a Discount, apply it
          if pDiscountRate is not null then
             pDiscount := ( pMasterSP / 100 ) * pDiscountRate;
          else
             pDiscount := null;
          end if;

          pSellPrice := pMasterSP;
          pSellPriceType := 3;
       end if;

    end if;

-- Step 9 : Return Findings

  ret_price.err_code := 0;
  ret_price.err_text := 'Success';
  ret_price.pt := aProductType;
  ret_price.plu := pPLu;
  ret_price.plu_description := pDescription;
  ret_price.product_code := pProdCode;
  ret_price.product_description := pProdDescription;
  ret_price.cost_price := pCostPrice;
  ret_price.vat_code := pVatCode;
  ret_price.vat_rate := pVatRate;
  ret_price.master_price := pMasterSP;
  ret_price.promotional_price := pPromoSP;
  ret_price.customer_price := pCustomerSP;
  ret_price.sell_price := pSellPrice;
  ret_price.discount_rate := pDiscountRate;
  ret_price.discount_value := pDiscount;
  ret_price.sell_pricetype := pSellPriceType;
  ret_price.stock_unit := pStockUnit;

  return ret_price;

end;
$BODY$
 LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION getpluprices(aproducttype integer, apricelist integer, adiscstruct integer) OWNER TO postgres;


-- View: "v_cust_p_danal"


DROP VIEW v_cust_turnover CASCADE;
DROP VIEW v_cust_total CASCADE;
DROP VIEW v_cust_p_danal;

CREATE OR REPLACE VIEW v_cust_p_danal AS
SELECT ih."location", ih.ac_location, ih.cust, ixd.pdesc AS plantorprod, ih.period, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
           ELSE ixd.goods
       END) AS amount, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.qty * (-1)
           ELSE ixd.qty
       END) AS qty
  FROM ihead ih, iddetail ixd
 WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust
 GROUP BY ih."location", ih.ac_location, ih.cust, ixd.pdesc, ih.period;

ALTER TABLE v_cust_p_danal OWNER TO postgres;



-- View: "v_cust_p_hanal"

DROP VIEW v_cust_p_hanal;

CREATE OR REPLACE VIEW v_cust_p_hanal AS
SELECT ih."location", ih.ac_location, ih.cust, ixd.plant_desc AS plantorprod, ih.period, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
           ELSE ixd.goods
       END) AS amount, 0 AS qty
  FROM ihead ih, ihdetail ixd
 WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust
 GROUP BY ih."location", ih.ac_location, ih.cust, ixd.plant_desc, ih.period;

ALTER TABLE v_cust_p_hanal OWNER TO postgres;

-- View: "v_cust_p_hanal_no_x"

-- DROP VIEW v_cust_p_hanal_no_x;

CREATE OR REPLACE VIEW v_cust_p_hanal_no_x AS
SELECT ih."location", ih.ac_location, ih.cust, ixd.plant_desc AS plantorprod, ih.period, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
           ELSE ixd.goods
       END) AS amount, 0 AS qty
  FROM ihead ih, ihdetail ixd
 WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust AND ixd.plant_ref <> '9'::bpchar
 GROUP BY ih."location", ih.ac_location, ih.cust, ixd.plant_desc, ih.period;

ALTER TABLE v_cust_p_hanal_no_x OWNER TO postgres;

-- View: "v_cust_p_sanal"

-- DROP VIEW v_cust_p_sanal;

CREATE OR REPLACE VIEW v_cust_p_sanal AS
SELECT ih."location", ih.ac_location, ih.cust, ixd.product AS plantorprod, ih.period, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
           ELSE ixd.goods
       END) AS amount, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.qty * (-1)::numeric
           ELSE ixd.qty
       END) AS qty
  FROM ihead ih, iodetail ixd
 WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust
 GROUP BY ih."location", ih.ac_location, ih.cust, ixd.product, ih.period;

ALTER TABLE v_cust_p_sanal OWNER TO postgres;

-- View: "v_cust_p_xanal"

-- DROP VIEW v_cust_p_xanal;

CREATE OR REPLACE VIEW v_cust_p_xanal AS
SELECT ih."location", ih.ac_location, ih.cust, ixd.plant_desc AS plantorprod, ih.period, sum(
       CASE ih.doc_type
           WHEN 'CR'::bpchar THEN ixd.goods * (-1)::numeric
           ELSE ixd.goods
       END) AS amount, 0 AS qty
  FROM ihead ih, ihdetail ixd
 WHERE ih.doc_type = ixd.doc_type AND ih."location" = ixd."location" AND ih.ref = ixd.ref AND ih.cust = ixd.cust AND ixd.plant_ref = '9'::bpchar
 GROUP BY ih."location", ih.ac_location, ih.cust, ixd.plant_desc, ih.period;

ALTER TABLE v_cust_p_xanal OWNER TO postgres; 


-- recreate parent views v_cust_total and v_cust_turnover

CREATE OR REPLACE VIEW v_cust_total AS 
( SELECT v_cust_p_hanal.ac_location, v_cust_p_hanal.cust, v_cust_p_hanal.period, sum(v_cust_p_hanal.amount) AS amount
   FROM v_cust_p_hanal
  GROUP BY v_cust_p_hanal.ac_location, v_cust_p_hanal.cust, v_cust_p_hanal.period
UNION ALL 
 SELECT v_cust_p_sanal.ac_location, v_cust_p_sanal.cust, v_cust_p_sanal.period, sum(v_cust_p_sanal.amount) AS amount
   FROM v_cust_p_sanal
  GROUP BY v_cust_p_sanal.ac_location, v_cust_p_sanal.cust, v_cust_p_sanal.period)
UNION ALL 
 SELECT v_cust_p_danal.ac_location, v_cust_p_danal.cust, v_cust_p_danal.period, sum(v_cust_p_danal.amount) AS amount
   FROM v_cust_p_danal
  GROUP BY v_cust_p_danal.ac_location, v_cust_p_danal.cust, v_cust_p_danal.period;

ALTER TABLE v_cust_total OWNER TO postgres;

CREATE OR REPLACE VIEW v_cust_turnover AS 
 SELECT v_cust_total.ac_location, v_cust_total.cust, v_cust_total.period, sum(v_cust_total.amount) AS amount
   FROM v_cust_total
  GROUP BY v_cust_total.ac_location, v_cust_total.cust, v_cust_total.period;

ALTER TABLE v_cust_turnover OWNER TO postgres;


