
--
-- Create the primary keys required to support the FK process
--

alter table vat modify cod smallint not null primary key;

--
-- Fix calender
--

delete   from calendar
where dat is null;

--
-- Fix cust_ext
--

update cust_ext
set sales_rep = 1
where sales_rep is null;
update cust_ext
set credit_controller=1
where credit_controller is null;

-- Fix cust
update cust
set staff = 0
where staff is null;

--
-- Fix hmhead dupes
--
unload to hmdupelist.unl
select location, doc_type, doc_number,count(*)
from hmhead
group by 1,2,3
having count(*) > 1;



--
-- Fix serials on unmatched_history
--
unload to uhfix.unl select period, 0, asset_reg, pdesc, reg, qty, dat, cost_per_unit, supplier, qty_left, qty_sold, location
from unmatched_history;
drop table unmatched_history;
create table unmatched_history
  (
    period date,
    ser serial not null ,
    asset_reg char(1),
    pdesc char(4),
    reg char(6),
    qty integer,
    dat date,
    cost_per_unit decimal(9,2),
    supplier char(6),
    qty_left integer,
    qty_sold integer,
    location smallint
  );
load from uhfix.unl insert into unmatched_history;
create index hsunmatchx on unmatched_history (pdesc,
    reg) using btree ;
create index hsunmatchx2 on unmatched_history (supplier)
    using btree ;
alter table unmatched_history add constraint (foreign
    key (supplier) references supplier  constraint unmatched_history_fk1);


--drop index iodetnsuk;
alter table hrates modify(tender char(8));
alter table tender add constraint unique (cod);
alter table pdesc add constraint unique (cod);
alter table iodetail add constraint primary key (nsuk);
alter table stk_freeze_hdr modify (operator_id smallint);
alter table sallocper modify (operator smallint);
alter table pt_msales modify (sales_rep smallint);
alter table pi_head  modify (entered_by smallint);
alter table pallocper modify (operator smallint);
alter table ioh_sale modify (sales_rep smallint);
alter table ioh_hire modify (sales_rep smallint);
alter table ioh_disp modify (sales_rep smallint);
alter table ihead modify (sales_rep int);
alter table cust_order modify (operator smallint);
alter table cust_order modify (sales_rep smallint);
alter table cust_order modify (quotation integer);
alter table cust_order modify (site smallint);
alter table cust_order modify (depot smallint);
alter table cust_order modify (location smallint);
alter table cust_ext modify (credit_controller smallint);
alter table cust_ext modify (sales_rep smallint);
alter table cod_allocation modify (location smallint);
alter table cod_allocation modify (lin smallint);
alter table cn_head modify (entered_by smallint);
alter table stock_location modify (depot smallint);
alter table stock_freeze modify (depot smallint);
alter table stk_take_wrk modify (location smallint);
alter table bin_location modify (location smallint);
alter table sallocper modify (acdepot smallint);
alter table cust_pricelist modify (depot smallint);
alter table cust_discstruct modify (depot smallint);
alter table cust_ext modify (depot smallint);
alter table stk_freeze_dtl modify (location smallint);
alter table sledger_query modify (depot smallint);

drop index chdetx1;
alter table chdetail add constraint primary key (location, contract, lin);
drop index custsitex;
alter table custsite add constraint primary key (depot, cust, site);
alter table depot add constraint primary key(cod);
alter table cc_detail add constraint primary key(nsuk);
alter table hire_dept add constraint primary key(nsuk);
delete from tender where cod is null;
--alter table tender add constraint primary key(cod);
drop index nlbatch2x;
--------------------------------------------------------------------------------
unload to "nlbatchnullkey.unl"
select * from nlbatch
where source is null or seq is null;
delete from nlbatch where source is null or seq is null;

alter table nlbatch add constraint primary key (source, seq);
--------------------------------------------------------------------------------


alter table disposals add constraint primary key (ser);
alter table phistory add constraint primary key (ser);
alter table po_detail modify(nominal char(6));
alter table product add constraint primary key(nsuk);
alter table operator modify(cod integer not null);
alter table operator add constraint primary key (cod);
alter table quote add constraint primary key (nsuk);
alter table unmatched_history add constraint primary key (ser);
alter table unmatched add constraint primary key (ser);
alter table trans modify cod smallint not null primary key;
alter table team add constraint primary key (nsuk);
alter table team_module add constraint primary key (nsuk);
alter table team_menu add constraint primary key (nsuk);
alter table team_member add constraint primary key (nsuk);
alter table suspend_reasons add constraint primary key (nsuk);
alter table support_detail add constraint primary key (nsuk);
alter table support add constraint primary key (ser);
alter table supplier_ext add constraint primary key (nsuk);
ALTER TABLE stock_location ADD constraint primary key (nsuk);
ALTER TABLE stock_freeze MODIFY period CHAR(7);
ALTER TABLE stock_freeze ADD constraint primary key (nsuk);
ALTER TABLE stk_header ADD constraint primary key (nsuk);
ALTER TABLE stk_freeze_hdr MODIFY timestamp datetime year to second;
ALTER TABLE source ADD constraint primary key (cod);
ALTER TABLE so_head ADD constraint primary key (nsuk);
ALTER TABLE so_detail ADD constraint primary key (nsuk);
ALTER TABLE sledger_query ADD constraint primary key (nsuk);
ALTER TABLE sledger ADD constraint primary key (ser);
ALTER TABLE signs ADD constraint primary key (doc_type);
ALTER TABLE scontact ADD constraint primary key (nsuk);
--drop index pk_allocper_ix;
ALTER TABLE sallocper ADD constraint primary key (allocation);
ALTER TABLE sales_invoice ADD constraint primary key (nsuk);
ALTER TABLE s_wsales ADD constraint primary key (nsuk);
ALTER TABLE rpt_distribution ADD constraint primary key (nsuk);
ALTER TABLE rpt_dist_detail ADD constraint primary key (nsuk);
ALTER TABLE reserved_ac ADD constraint primary key (nsuk);
ALTER TABLE recurring_jrnl ADD constraint primary key (nsuk);
ALTER TABLE pt_ysales ADD constraint primary key (nsuk);
ALTER TABLE pt_wsales ADD constraint primary key (nsuk);
--drop index pt_supp_x1;
ALTER TABLE pt_supplier ADD constraint primary key (nsuk);
ALTER TABLE pt_serial MODIFY (gi_detail integer);
ALTER TABLE pt_pdesc ADD constraint primary key (nsuk);
ALTER TABLE pt_part ADD constraint primary key (nsuk);
ALTER TABLE pt_option ADD constraint primary key (nsuk);
ALTER TABLE pt_msales ADD constraint primary key (nsuk);
ALTER TABLE pt_bin_loc ADD constraint primary key (nsuk);
ALTER TABLE project ADD constraint primary key (nsuk);
ALTER TABLE printer_trigger ADD constraint primary key (nsuk);
ALTER TABLE pricelist_det ADD constraint primary key (nsuk);
ALTER TABLE policy ADD constraint primary key (nam);
--drop index ind_1;
ALTER TABLE pmsg ADD constraint primary key (msg_typ);
ALTER TABLE plnlxref ADD constraint primary key (nsuk);
ALTER TABLE pledgerext ADD constraint primary key (pledger_ser);
--Not now Cato
ALTER TABLE pi_status ADD constraint primary key (nsuk);
ALTER TABLE pdesc_ext ADD constraint primary key (pdesc);
ALTER TABLE pdesc ADD constraint unique (asset_reg, cod);
--ALTER TABLE pcost ADD constraint primary key (ser);
ALTER TABLE part_name ADD constraint primary key (nsuk);
ALTER TABLE o_allocation ADD constraint primary key (nsuk);
-- clear out duplicate type 5's on movement type and recreate with reference of 100,000
delete from movement_typ where nsuk = 5;
insert into movement_typ values(5,'Return from Contract','N',100000);
ALTER TABLE movement_typ ADD constraint primary key (nsuk);
ALTER TABLE lodgement ADD constraint primary key (cod);
ALTER TABLE licence ADD constraint primary key (nsuk);
ALTER TABLE journals ADD constraint primary key (ser);
drop index io_iodetnsuk;
ALTER TABLE ioh_sale ADD constraint primary key (nsuk);
ALTER TABLE iod_allocation ADD constraint primary key (nsuk);
--drop index pk_ihead_ix;
--ALTER TABLE ihead ADD constraint unique (nsuk);
--drop index pk_ihdetail_ix;
--ALTER TABLE ihdetail ADD constraint primary key (nsuk);
--drop index pk_iddetail_ix;
--ALTER TABLE iddetail ADD constraint primary key (nsuk);
ALTER TABLE hrates ADD constraint primary key (nsuk);
ALTER TABLE hm_rental ADD constraint primary key (nsuk);
ALTER TABLE hire_dept_group ADD constraint primary key (nsuk);
ALTER TABLE g_ihead ADD constraint primary key (nsuk);
ALTER TABLE freeze_gid ADD constraint primary key (nsuk);
ALTER TABLE driver ADD constraint primary key (nsuk);
ALTER TABLE dispxref ADD constraint primary key (ser);
ALTER TABLE disptypes ADD constraint primary key (cod);
ALTER TABLE disc_struct ADD constraint primary key (nsuk);
ALTER TABLE disc_detail ADD constraint primary key (nsuk);
ALTER TABLE dept_group ADD constraint primary key (nsuk);
ALTER TABLE dept ADD constraint primary key (nsuk);
ALTER TABLE default_profile ADD constraint primary key (nsuk);
ALTER TABLE ddso_xref ADD constraint primary key (nsuk);
ALTER TABLE dcsmaillog ADD constraint primary key (nsuk);
ALTER TABLE d_wsales ADD constraint primary key (nsuk);
ALTER TABLE d_msales ADD constraint primary key (nsuk);
ALTER TABLE cust_pricelist ADD constraint primary key (nsuk);
ALTER TABLE cust_discstruct ADD constraint primary key (nsuk);
ALTER TABLE cr_typ ADD constraint primary key (typ);
delete from contact_type where cod = 'O';
insert into contact_type values ('O', 'Other');
ALTER TABLE contact_type ADD constraint primary key (cod);
ALTER TABLE contact ADD constraint primary key (nsuk);
ALTER TABLE cod_allocation ADD constraint primary key (nsuk);
ALTER TABLE cn_pid_xref ADD constraint primary key (nsuk);
ALTER TABLE charge_lines ADD constraint primary key (nsuk);
ALTER TABLE cc_status ADD constraint primary key (nsuk);
ALTER TABLE bin_location ADD constraint primary key (nsuk);
ALTER TABLE bank_accounts MODIFY cod CHAR(6);
DELETE FROM singles where cod is null;
--ALTER TABLE singles ADD constraint primary key (asset_reg, pdesc, cod) CONSTRAINT singx ;
ALTER TABLE note ADD constraint primary key (seq, lin) CONSTRAINT ux_note ;
--drop index pk_inv_details_ix;
--ALTER TABLE inv_details ADD constraint primary key (nsuk) CONSTRAINT inv_details_pkey ;
--ALTER TABLE ihead ADD constraint primary key (doc_type, location, ref, cust) CONSTRAINT ihead_pkey ;
--drop index hmhix1; [TODO]
--
-- There are duplicates on hmhead
--
--ALTER TABLE hmhead ADD constraint primary key (location, doc_type, doc_number) CONSTRAINT hmhix1 ;
ALTER TABLE custlist ADD constraint primary key (cust, depot, list_name) CONSTRAINT custlist_idx ;
ALTER TABLE cust_ext ADD constraint primary key (cod, depot) CONSTRAINT cust_ext_idx ;
ALTER TABLE codetail ADD constraint primary key (location, contract, lin) CONSTRAINT codetail_pkey ;
drop index cheadx1;
ALTER TABLE chead ADD constraint primary key (location, contract) CONSTRAINT chead_pkey ;
ALTER TABLE chdetailext ADD constraint primary key (lin, contract, location) CONSTRAINT chdetailext_idx ;
ALTER TABLE ccentre ADD constraint primary key (cod) CONSTRAINT ccentre_pkey ;
ALTER TABLE asset_reg ADD constraint primary key (cod) CONSTRAINT asset_reg_pkey ;
ALTER TABLE po_detail ADD constraint primary key (nsuk) CONSTRAINT podetail_pkey ;
ALTER TABLE po_status ADD constraint primary key (nsuk) CONSTRAINT po_status_pkey ;
ALTER TABLE gi_detail ADD constraint primary key (nsuk) CONSTRAINT gidetail_pkey ;
ALTER TABLE po_head ADD constraint primary key (nsuk) CONSTRAINT po_head_pkey ;
ALTER TABLE pi_head ADD constraint primary key (nsuk) CONSTRAINT pi_head_pkey ;
ALTER TABLE pi_detail ADD constraint primary key (nsuk) CONSTRAINT pi_detail_pkey ;
ALTER TABLE cn_detail ADD constraint primary key (nsuk) CONSTRAINT cn_detail_pkey ;
ALTER TABLE cn_head ADD constraint primary key (nsuk) CONSTRAINT cn_head_pkey ;
